<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  
  
  <link rel="shortcut icon" href="../img/favicon.ico">
  <title>LFortran Design - LFortran Documentation</title>
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato:400,700|Roboto+Slab:400,700|Inconsolata:400,700" />

  <link rel="stylesheet" href="../css/theme.css" />
  <link rel="stylesheet" href="../css/theme_extra.css" />
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/10.5.0/styles/github.min.css" />
  <link href="../ansi.css" rel="stylesheet" />
  
  <script>
    // Current page data
    var mkdocs_page_name = "LFortran Design";
    var mkdocs_page_input_path = "design.md";
    var mkdocs_page_url = null;
  </script>
  
  <script src="../js/jquery-2.1.1.min.js" defer></script>
  <script src="../js/modernizr-2.8.3.min.js" defer></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/10.5.0/highlight.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/10.5.0/languages/fortran.min.js"></script>
  <script>hljs.initHighlightingOnLoad();</script> 
</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side stickynav">
    <div class="wy-side-scroll">
      <div class="wy-side-nav-search">
        <a href=".." class="icon icon-home"> LFortran Documentation</a>
        <div role="search">
  <form id ="rtd-search-form" class="wy-form" action="../search.html" method="get">
      <input type="text" name="q" placeholder="Search docs" title="Type search term here" />
  </form>
</div>
      </div>

      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
                <ul>
                    <li class="toctree-l1"><a class="reference internal" href="..">Home</a>
                    </li>
                </ul>
                <ul>
                    <li class="toctree-l1"><a class="reference internal" href="../installation/">Installation</a>
                    </li>
                </ul>
                <ul>
                    <li class="toctree-l1"><a class="reference internal" href="../language/">Fortran Language</a>
                    </li>
                </ul>
                <ul>
                    <li class="toctree-l1"><a class="reference internal" href="../progress/">LFortran Development Status</a>
                    </li>
                </ul>
                <p class="caption"><span class="caption-text">Developer's Guide</span></p>
                <ul class="current">
                    <li class="toctree-l1 current"><a class="reference internal current" href="./">LFortran Design</a>
    <ul class="current">
    <li class="toctree-l2"><a class="reference internal" href="#high-level-overview">High Level Overview</a>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#asr-design-details">ASR Design Details</a>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#notes">Notes:</a>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#fortran-2008">Fortran 2008</a>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#lfortran-extension">LFortran Extension</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#example-1">Example 1</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#example-2">Example 2</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#example-3">Example 3</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#example-4">Example 4</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#design-considerations">Design Considerations</a>
    </li>
    </ul>
                    </li>
                    <li class="toctree-l1"><a class="" href="../developer_tutorial.md">None</a>
                    </li>
                    <li class="toctree-l1"><a class="" href="../AST and ASR.md">None</a>
                    </li>
                    <li class="toctree-l1"><a class="reference internal" href="../contribution/">Contributing</a>
                    </li>
                </ul>
      </div>
    </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="..">LFortran Documentation</a>
      </nav>

      
      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="..">Docs</a> &raquo;</li>
    
      
        
          <li>Developer's Guide &raquo;</li>
        
      
    
    <li>LFortran Design</li>
    <li class="wy-breadcrumbs-aside">
      
    </li>
  </ul>
  
  <hr/>
</div>

          <div role="main">
            <div class="section">
              
                <h1 id="lfortran-design">LFortran Design</h1>
<h2 id="high-level-overview">High Level Overview</h2>
<p>LFortran is structured around two independent modules, AST and ASR, both of
which are standalone (completely independent of the rest of LFortran) and users
are encouraged to use them independently for other applications and build tools
on top:</p>
<ul>
<li>
<p>Abstract Syntax Tree (AST), module <code>lfortran.ast</code>: Represents any Fortran
  source code, strictly based on syntax, no semantic is included. The AST
  module can convert itself to Fortran source code.</p>
</li>
<li>
<p>Abstract Semantic Representation (ASR), module <code>lfortran.asr</code>: Represents a valid
  Fortran source code, all semantic is included. Invalid Fortran code is not
  allowed (an error will be given). The ASR module can convert itself to an
  AST.</p>
</li>
</ul>
<p>The LFortran compiler is then composed of the following independent stages:</p>
<ul>
<li>Parsing: converts Fortran source code to an AST</li>
<li>Semantic: converts an AST to an ASR</li>
<li>High level optimizations: optimize ASR to a possibly faster/simpler ASR
  (things like inlining functions, eliminating redundant expressions or
  statements, etc.)</li>
<li>LLVM IR code generation and lower level optimizations: converts an ASR to an
  LLVM IR. This stage also does all other optimizations that do not produce an
  ASR, but still make sense to do before passing to LLVM IR.</li>
<li>Machine code generation: LLVM then does all its optimizations and generates
  machine code (such as a binary executable, a library, an object file, or it
  is loaded and executed using JIT as part of the interactive LFortran session
  or in a Jupyter kernel).</li>
</ul>
<p>LFortran is structured as a library, and so one can for example use the parser
to obtain an AST and do something with it, or one can then use the semantic
analyzer to obtain ASR and do something with it. One can generate the ASR
directly (e.g., from SymPy) and then either convert to AST and to a Fortran
source code, or use LFortran to compile it to machine code directly. In other
words, one can use LFortran to easily convert between the three equivalent
representations:</p>
<ul>
<li>Fortran source code</li>
<li>Abstract Syntax Tree (AST)</li>
<li>Abstract Semantic Representation (ASR)</li>
</ul>
<p>They are all equivalent in the following sense:</p>
<ul>
<li>Any ASR can always be converted to an equivalent AST</li>
<li>Any AST can always be converted to an equivalent Fortran source code</li>
<li>Any Fortran source code can always be either converted to an equivalent AST
  or one gets a syntax error</li>
<li>Any AST can always be either converted to an equivalent ASR or one gets a
  semantic error</li>
</ul>
<p>So when a conversion can be done, they are equivalent, and the conversion can
always be done unless the code is invalid.</p>
<h2 id="asr-design-details">ASR Design Details</h2>
<p>The ASR is designed to have the following features:</p>
<ul>
<li>
<p>ASR is still semantically equivalent to the original Fortran code (it did not
  lose any semantic information). ASR can be converted to AST, and AST to
  Fortran source code which is functionally equivalent to the original.</p>
</li>
<li>
<p>ASR is as simple as possible: it does not contain any information that could
  not be inferred from ASR.</p>
</li>
<li>
<p>The ASR C++ classes (down the road) are designed similarly to SymEngine: they
  are constructed once and after that they are immutable. The constructor
  checks in Debug more that all the requirements are met (e.g., that all
  Variables in a Function have a dummy argument set, that explicit-shape arrays
  are not allocatable and all other Fortran requirements to make it a valid
  code), but in Release mode it quickly constructs the class without checks.
  Then there are builder classes that construct the ASR C++ classes to meet
  requirements (checked in Debug mode) and the builder gives an error message
  if a code is not a valid Fortran code, and if it doesn't give an error
  message, then the ASR C++ classes are constructed correctly. Thus by
  construction, the ASR classes always contain valid Fortran code and the rest
  of LFortran can depend on it.</p>
</li>
</ul>
<h2 id="notes">Notes:</h2>
<p>Information that is lost when parsing source to AST:
whitespace, multiline/single line if statement distinction, case sensitivity of keywords.</p>
<p>Information that is lost when going from AST to ASR:
detailed syntax how variables were defined and the order of type attributes (whether array dimension is using the <code>dimension</code> attribute, or parentheses at the variable; or how many variables there are per declaration line or their order), as ASR only represents the aggregated type information in the symbol table.</p>
<p>ASR is the simplest way to generate Fortran code, as one does not
have to worry about the detailed syntax (as in AST) about how and where
things are declared. One specifies the symbol table for a module, then for
each symbol (functions, global variables, types, ...) one specifies the local
variables and if this is an interface then one needs to specify where one can
find an implementation, otherwise a body is supplied with statements, those
nodes are almost the same as in AST, except that each variable is just a
reference to a symbol in the symbol table (so by construction one cannot have
undefined variables). The symbol table for each node such as Function or Module
also references its parent (for example a function references a module,
a module references the global scope).</p>
<p>The ASR can be directly converted to an AST without gathering any other
information. And the AST directly to Fortran source code.</p>
<p>The ASR is always representing a semantically valid Fortran code.  This is
enforced by checks in the ASR C++ constructors (in Debug build).
When an ASR is used, one can assume it is valid.</p>
<h2 id="fortran-2008">Fortran 2008</h2>
<p>Fortran 2008 <a href="https://j3-fortran.org/doc/year/10/10-007.pdf">standard</a> chapter
2 "Fortran concepts" specifies that Fortran code is a collection of <em>program
units</em> (either all in one file, or in separate files), where each <em>program
unit</em> is one of:</p>
<ul>
<li>main program</li>
<li>module or submodule</li>
<li>function or subroutine</li>
</ul>
<p>Note: It can also be a <em>block data</em> program unit, that is used to provide
initial values for data objects in named <em>common blocks</em>, but we do not
recommend the use of <em>common blocks</em> (use modules instead).</p>
<h2 id="lfortran-extension">LFortran Extension</h2>
<p>We extend the Fortran language by introducing a <em>global scope</em>, which is not
only the list of <em>program units</em> (as in F2008) but can also include statements,
declarations, use statements and expressions. We define <em>global scope</em> as a
collection of the following items:</p>
<ul>
<li>main program</li>
<li>module or submodule</li>
<li>function or subroutine</li>
<li>use statement</li>
<li>declaration</li>
<li>statement</li>
<li>expression</li>
</ul>
<p>In addition, if a variable is not defined in an assignment statement (such as
<code>x = 5+3</code>) then the type of the variable is inferred from the right hand side
(e.g., <code>x</code> in <code>x = 5+3</code> would be of type <code>integer</code>, and <code>y</code> in <code>y = 5._dp</code>
would be of type <code>real(dp)</code>). This rule only applies at the top level of
<em>global scope</em>. Types must be fully specified inside main programs, modules,
functions and subroutines, just like in F2008.</p>
<p>The <em>global scope</em> has its own symbol table. The main program and
module/submodule do not see any symbols from this symbol table. But functions,
subroutines, statements and expressions at the top level of <em>global scope</em> use
and operate on this symbol table.</p>
<p>The <em>global scope</em> has the following symbols predefined in the symbol table:</p>
<ul>
<li>the usual standard set of Fortran functions (such as <code>size</code>,
  <code>sin</code>, <code>cos</code>, ...)</li>
<li>the <code>dp</code> double precision symbol, so that one can use <code>5._dp</code> for double
  precision.</li>
</ul>
<p>Each item in the <em>global scope</em> is interpreted as follows: main program is
compiled into an executable with the same name and executed; modules,
functions and subroutines are compiled and loaded; use statement and
declaration adds those symbols with the proper type into the <em>global scope</em>
symbol table, but do not generate any code; statement is wrapped into an
anonymous subroutine with no arguments, compiled, loaded and executed;
expression is wrapped into an anonymous function with no arguments returning
the expression, compiled, loaded, executed and the return value is returned
to the user.</p>
<p>The <em>global scope</em> is always interpreted, item by item, per the previous
paragraph. It is meant to allow interactive usage, experimentations and
writing simple scripts. Code in <em>global scope</em> must be interpreted using
<code>lfortran</code>. For more complex (production) code it is recommended to turn it
into modules and programs (by wrapping loose statements into subroutines or
functions and by adding type declarations) and compile it with <code>lfortran</code> or
any other Fortran compiler.</p>
<p>Here are some examples of valid code in <em>global scope</em>:</p>
<h3 id="example-1">Example 1</h3>
<pre><code class="language-fortran">a = 5
print *, a
</code></pre>
<h3 id="example-2">Example 2</h3>
<pre><code class="language-fortran">a = 5

subroutine p()
print *, a
end subroutine

call p()
</code></pre>
<h3 id="example-3">Example 3</h3>
<pre><code class="language-fortran">module a
implicit none
integer :: i
end module

use a, only: i
i = 5
</code></pre>
<h3 id="example-4">Example 4</h3>
<pre><code class="language-fortran">x = [1, 2, 3]
y = [1, 2, 1]
call plot(x, y, &quot;o-&quot;)
</code></pre>
<h2 id="design-considerations">Design Considerations</h2>
<p>The LFortran extension of Fortran was chosen in a way so as to minimize the
number of changes. In particular, only the top level of the <em>global scope</em>
has relaxed some of the Fortran rules (such as making specifying types
optional) so as to allow simple and quick interactive usage, but inside
functions, subroutines, modules or programs this relaxation does not apply.</p>
<p>The number of changes were kept to minimum in order to make it
straightforward to turn code at <em>global scope</em> into standard compliant
Fortran code using programs and modules, so that it can be compiled by any
Fortran compiler.</p>
              
            </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../contribution/" class="btn btn-neutral float-right" title="Contributing">Next <span class="icon icon-circle-arrow-right"></span></a>
      
      
        <a href="../progress/" class="btn btn-neutral" title="LFortran Development Status"><span class="icon icon-circle-arrow-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <!-- Copyright etc -->
    
  </div>

  Built with <a href="https://www.mkdocs.org/">MkDocs</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>.
</footer>
      
        </div>
      </div>

    </section>

  </div>

  <div class="rst-versions" role="note" aria-label="versions">
  <span class="rst-current-version" data-toggle="rst-current-version">
    
    
      <span><a href="../progress/" style="color: #fcfcfc">&laquo; Previous</a></span>
    
    
      <span><a href="../contribution/" style="color: #fcfcfc">Next &raquo;</a></span>
    
  </span>
</div>
    <script>var base_url = '..';</script>
    <script src="../js/theme_extra.js" defer></script>
    <script src="../js/theme.js" defer></script>
      <script src="../search/main.js" defer></script>
    <script defer>
        window.onload = function () {
            SphinxRtdTheme.Navigation.enable(true);
        };
    </script>

</body>
</html>
